#include "port.h"

static unsigned short rts = 0, dtr = 0;


int tty;

/* 
 * 'open_port()'   Open serial port 1. 
 * 
 * Returns the file descriptor on success or  1 on error. 
 */ 
int port_open(char *port)
{
  int status = 0;

  tty = open(port, O_RDWR /*| O_NOCTTY*/ | O_NDELAY);
  if (tty == -1) {
    /*
     * Could not open the port.
     */
    perror("Otevirani portu:");
    exit(1);
  }
  else {
    fcntl(tty, F_SETFL, 0);
    if(ioctl(tty, TIOCMSET, &status) == -1)
      perror("chyba ioctl()");
  }
  return (tty);
}


int port_set(int linka, int on_off)
{

  unsigned short status;
  static time_t posledni_zmena = 0;
  time_t pom_cas;
  static time_t posledni_zmena2 = 0;
  time_t pom_cas2;

  if((linka == 0) && (posledni_zmena2 < time(&pom_cas2)-2)) {
    if(on_off == 0)
      rts = 0;
    else if(on_off == 1)
      rts = TIOCM_RTS;
    else
      return 1;
    posledni_zmena2 = pom_cas2;
  }
  else if((linka == 1) && (posledni_zmena < time(&pom_cas)-2)) {  /* test na posledni zmenu */
    if(on_off == 0)
      dtr = 0;
    else if(on_off == 1)
      dtr = TIOCM_DTR;
    else
      return 1;

    posledni_zmena = pom_cas;
  }
  else
    return 1;

  status = (rts | dtr);

  if(ioctl(tty, TIOCMSET, &status) == -1)  {
    /*perror("chyba ioctl()");*/
    return 1;

  }

  return 0;
}

int port_read(int linka)
{
  if(linka == 0)
    return rts ? 1 : 0;
  else
    return dtr ? 1 : 0;
}
